"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf3 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _reactImmutableProptypes = _interopRequireDefault(require("react-immutable-proptypes"));

var _partial = _interopRequireDefault(require("lodash/partial"));

var _uiElements = require("@instructure/ui-elements");

var _uiA11y = require("@instructure/ui-a11y");

var _uiButtons = require("@instructure/ui-buttons");

var _uiMenu = require("@instructure/ui-menu");

var _uiIcons = require("@instructure/ui-icons");

var _uiAlerts = require("@instructure/ui-alerts");

var _uiThemeable = require("@instructure/ui-themeable");

var _CustomPropTypes = _interopRequireDefault(require("../../../common/util/CustomPropTypes"));

var _IfFeature = _interopRequireDefault(require("../../../common/components/shared/IfFeature"));

var _EditBankModal = _interopRequireDefault(require("../EditBankModal"));

var _SharingModal = _interopRequireDefault(require("../SharingModal"));

var _formatMessage = _interopRequireDefault(require("@instructure/quiz-i18n/lib/format-message"));

var _quizCommon = require("@instructure/quiz-common");

var _theme = _interopRequireDefault(require("./theme"));

var _dec, _class, _class2, _temp;

var styles = {
  componentId: 'eShTv',
  template: function template(theme) {
    return "\n\n.eShTv_dIMK{border-bottom:".concat(theme.bankRowBorderWidth || 'inherit', " solid ").concat(theme.bankRowBorderColor || 'inherit', ";display:flex;flex-direction:row}\n\n.eShTv_Zupb{flex:1;margin:").concat(theme.bankInfoMargin || 'inherit', " 0}\n\n.eShTv_qnWp{font-size:").concat(theme.bankTitleFontSize || 'inherit', ";padding-bottom:").concat(theme.bankTitlePadding || 'inherit', "}\n\n.eShTv_ciks{color:").concat(theme.bankDetailsColor || 'inherit', ";font-size:").concat(theme.bankDetailsFontSize || 'inherit', "}\n\n.eShTv_cCNg{margin:").concat(theme.bankOptionsMargin || 'inherit', " 0}\n\n.eShTv_bISW{font-size:").concat(theme.BankOptionIconFontSize || 'inherit', ";margin-right:").concat(theme.BankOptionIconMargin || 'inherit', ";vertical-align:middle}\n\n.eShTv_AHIw{display:block}\n\n.eShTv_eTBd{margin-bottom:").concat(theme.deletePrefaceMargin || 'inherit', "}");
  },
  'bankRow': 'eShTv_dIMK',
  'bankInfo': 'eShTv_Zupb',
  'bankTitle': 'eShTv_qnWp',
  'bankDetails': 'eShTv_ciks',
  'bankOptions': 'eShTv_cCNg',
  'bankOptionIcon': 'eShTv_bISW',
  'deleteAlert': 'eShTv_AHIw',
  'deletePreface': 'eShTv_eTBd'
};
var BanksList = (_dec = (0, _uiThemeable.themeable)(_theme.default, styles), _dec(_class = (_temp = _class2 =
/*#__PURE__*/
function (_withI18nSupport) {
  (0, _inherits2.default)(BanksList, _withI18nSupport);

  function BanksList() {
    var _getPrototypeOf2;

    var _this;

    (0, _classCallCheck2.default)(this, BanksList);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = (0, _possibleConstructorReturn2.default)(this, (_getPrototypeOf2 = (0, _getPrototypeOf3.default)(BanksList)).call.apply(_getPrototypeOf2, [this].concat(args)));
    _this.state = {
      sharingModalOpen: false,
      sharingModalBank: null,
      sharingCount: null,
      countedBank: null
    };
    _this.sharingButtons = [];

    _this.openModal = function (bank) {
      return function () {
        _this.props.openModal([_quizCommon.EDIT_BANK_MODAL, bank.id].join(':'), {
          modalTrigger: _this.bankActionsButton
        });
      };
    };

    _this.bankActionsButtonRef = function (node) {
      _this.bankActionsButton = node;
    };

    _this.deleteBank = function (bankId) {
      _this.props.deleteBank(bankId);

      setTimeout(_this.props.focusCreateBankButton, 100);
    };

    _this.openDeleteBankModal = function (bankId) {
      return function () {
        var confirmBody = _react.default.createElement(_uiAlerts.Alert, {
          variant: "error",
          padding: "0"
        }, _react.default.createElement("div", {
          className: styles.deleteAlert
        }, _react.default.createElement("div", {
          className: styles.deletePreface
        }, (0, _formatMessage.default)('Once deleted, items from this bank:')), _react.default.createElement(_uiElements.List, null, _react.default.createElement(_uiElements.List.Item, null, (0, _formatMessage.default)('will no longer be accessible to others who currently have shared access')), _react.default.createElement(_uiElements.List.Item, null, _formatMessage.default.rich('will <0>NOT</0> be removed from any assessments', [function (_ref) {
          var children = _ref.children;
          return _react.default.createElement(_uiElements.Text, {
            weight: "bold",
            key: "0"
          }, children);
        }])), _react.default.createElement(_uiElements.List.Item, null, (0, _formatMessage.default)('will lose their statistical link in reporting (if they were part of an assessment)')), _react.default.createElement(_uiElements.List.Item, null, (0, _formatMessage.default)('will no longer be available to any assessments attempting a random/batch pull of items (removing the pull will resolve the issue)')))));

        _this.props.withConfirm((0, _partial.default)(_this.deleteBank, bankId), {
          text: confirmBody,
          title: (0, _formatMessage.default)('Delete Bank'),
          continueText: (0, _formatMessage.default)('Delete'),
          continueVariant: 'danger',
          size: 'medium'
        });
      };
    };

    _this.updateSharedCount = function (count) {
      _this.setState({
        sharingCount: count
      });
    };

    _this.openSharingModal = function (bank) {
      return function () {
        _this.setState({
          sharingModalOpen: true,
          sharingModalBank: bank,
          sharingCount: bank.sharedCount,
          countedBank: bank.id
        });
      };
    };

    _this.handleSharingModalDismiss = function () {
      _this.setState({
        sharingModalOpen: false,
        sharingModalBank: null
      });
    };

    _this.handleSharingButtonRef = function (bankId) {
      return function (node) {
        _this.sharingButtons[bankId] = node;
      };
    };

    _this.currentBankCount = function (bank) {
      var _this$state = _this.state,
          countedBank = _this$state.countedBank,
          sharingCount = _this$state.sharingCount;

      if (countedBank === bank.id && Number.isInteger(sharingCount)) {
        return sharingCount;
      }

      return bank.sharedCount;
    };

    _this.renderBankInfo = function (bank) {
      var navigateToBank = function navigateToBank(bankId) {
        return function () {
          return _this.props.navigateToBank(bankId);
        };
      };

      return _react.default.createElement("div", {
        className: styles.bankInfo,
        "data-automation": "sdk-bank-info",
        tabIndex: "-1"
      }, _react.default.createElement("div", {
        className: styles.bankTitle
      }, _react.default.createElement(_uiElements.Link, {
        onClick: navigateToBank(bank.id),
        theme: {
          color: _this.theme.bankTitleLinkColor,
          hoverColor: _this.theme.bankTitleLinkHoverColor
        },
        "data-automation": "sdk-banks-list-bank-title-link"
      }, _react.default.createElement(_uiElements.Heading, {
        as: "h2",
        level: "reset",
        "data-automation": "sdk-banks-list-bank-title-heading"
      }, bank.title))), _this.renderDetails(bank));
    };

    _this.renderBankOptions = function (bank) {
      return _react.default.createElement("div", {
        className: styles.bankOptions
      }, _react.default.createElement(_uiMenu.Menu, {
        trigger: _react.default.createElement(_uiButtons.Button, {
          variant: "icon",
          ref: _this.bankActionsButtonRef,
          "data-automation": "sdk-more-bank-actions-button",
          icon: _uiIcons.IconMoreSolid
        }, _react.default.createElement(_uiA11y.ScreenReaderContent, null, (0, _formatMessage.default)('More Bank Actions for { name }', {
          name: bank.title
        })))
      }, _react.default.createElement(_uiMenu.Menu.Item, {
        onSelect: _this.openModal(bank),
        "data-automation": "sdk-edit-bank-menu-item"
      }, _react.default.createElement(_uiIcons.IconEditLine, {
        className: styles.bankOptionIcon
      }), (0, _formatMessage.default)('Edit')), _react.default.createElement(_uiMenu.Menu.Item, {
        onSelect: _this.openDeleteBankModal(bank.id),
        "data-automation": "sdk-delete-bank-menu-item"
      }, _react.default.createElement(_uiIcons.IconTrashLine, {
        className: styles.bankOptionIcon
      }), (0, _formatMessage.default)('Delete'))));
    };

    _this.renderBank = function (bank) {
      return _react.default.createElement("div", {
        key: bank.id,
        className: styles.bankRow,
        "data-automation": "sdk-banks-list-bank-row"
      }, _react.default.createElement(_EditBankModal.default, {
        workingBank: bank.getWorkingInstance()
      }), _this.renderBankInfo(bank), _this.renderBankOptions(bank));
    };

    return _this;
  }

  (0, _createClass2.default)(BanksList, [{
    key: "renderDetails",
    value: function renderDetails(bank) {
      var numStimuli = bank.entryCount - bank.itemEntryCount;
      var separator = ' | ';
      return _react.default.createElement("div", {
        className: styles.bankDetails,
        "data-automation": "sdk-banks-list-bank-details"
      }, _react.default.createElement("div", null, (0, _formatMessage.default)('Updated { updatedDate }', {
        updatedDate: this.formatDateMedium(bank.updatedAt())
      }), _react.default.createElement(_uiA11y.PresentationContent, null, separator), (0, _formatMessage.default)("{\n              count, plural,\n              one {# Question Total}\n              other {# Questions Total}\n            }", {
        count: bank.itemEntryCount
      }), _react.default.createElement(_uiA11y.PresentationContent, null, separator), (0, _formatMessage.default)("{numQuestions} Associated Across\n              {numStimuli, plural,\n              one {# Stimulus}\n              other {# Stimuli}\n            }", {
        numQuestions: 0,
        numStimuli: numStimuli
      }), _react.default.createElement(_IfFeature.default, {
        name: "item_bank_sharing"
      }, _react.default.createElement(_uiA11y.PresentationContent, null, separator)), _react.default.createElement(_IfFeature.default, {
        name: "item_bank_sharing"
      }, _react.default.createElement(_uiElements.Link, {
        "data-automation": "sdk-shared-bank-share-link",
        as: "button",
        onClick: this.openSharingModal(bank),
        ref: this.handleSharingButtonRef(bank.id)
      }, this.currentBankCount(bank) > 0 ? "".concat((0, _formatMessage.default)('Sharing'), " (").concat(this.currentBankCount(bank), ")") : (0, _formatMessage.default)('+ Share')))));
    }
  }, {
    key: "renderSharingModal",
    value: function renderSharingModal() {
      return _react.default.createElement(_SharingModal.default, {
        appContainer: this.props.appContainer,
        bank: this.state.sharingModalBank,
        focusCreateBankButton: this.props.focusCreateBankButton,
        getUserInfo: this.props.getUserInfo,
        isOpen: this.state.sharingModalOpen,
        minChars: this.props.minChars,
        modalTrigger: this.sharingButtons[this.state.sharingModalBank.id],
        onDismiss: this.handleSharingModalDismiss,
        onShare: this.props.onShare,
        search: this.props.getShareableUsers,
        updateSharedCount: this.updateSharedCount
      });
    }
  }, {
    key: "render",
    value: function render() {
      return _react.default.createElement("div", null, this.state.sharingModalBank && this.renderSharingModal(), this.props.banks.toArray().map(this.renderBank));
    }
  }]);
  BanksList.displayName = "BanksList";
  return BanksList;
}((0, _quizCommon.withI18nSupport)(_react.Component)), _class2.propTypes = {
  appContainer: _CustomPropTypes.default.selectors.isRequired,
  banks: _reactImmutableProptypes.default.list.isRequired,
  focusCreateBankButton: _propTypes.default.func.isRequired,
  deleteBank: _propTypes.default.func.isRequired,
  getUserInfo: _propTypes.default.func,
  getShareableUsers: _propTypes.default.func,
  minChars: _propTypes.default.number,
  navigateToBank: _propTypes.default.func.isRequired,
  onShare: _propTypes.default.func,
  openModal: _propTypes.default.func.isRequired,
  withConfirm: _propTypes.default.func.isRequired,
  locale: _propTypes.default.string,
  timezone: _propTypes.default.string
}, _class2.defaultProps = {
  getUserInfo: null,
  getShareableUsers: null,
  minChars: void 0,
  locale: null,
  timezone: null,
  onShare: function onShare() {}
}, _class2.contextTypes = {
  locale: _propTypes.default.string,
  timezone: _propTypes.default.string
}, _temp)) || _class);
exports.default = BanksList;