"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.setFilter = exports.toggle = exports.update = exports.reset = void 0;

var _quizCommon = require("@instructure/quiz-common");

var reset = function reset() {
  return {
    type: _quizCommon.SEARCH_RESET
  };
};

exports.reset = reset;

var update = function update(text) {
  return {
    payload: {
      text: text
    },
    type: _quizCommon.SEARCH_UPDATE
  };
};

exports.update = update;

var toggle = function toggle(filter, key) {
  return {
    payload: {
      filter: filter,
      key: key
    },
    type: _quizCommon.SEARCH_TOGGLE
  };
};

exports.toggle = toggle;

var setFilter = function setFilter(filter, value) {
  return {
    payload: {
      filter: filter,
      value: value
    },
    type: _quizCommon.SEARCH_SET
  };
};

exports.setFilter = setFilter;