"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.archiveBank = exports.removeBank = exports.disassociateEntry = exports.associateEntries = exports.setBankFilters = exports.addBanks = void 0;

var _quizCommon = require("@instructure/quiz-common");

var addBanks = function addBanks(banks) {
  return {
    type: _quizCommon.ADD_BANKS,
    payload: banks
  };
};

exports.addBanks = addBanks;

var setBankFilters = function setBankFilters(bankId, filters) {
  return {
    type: _quizCommon.SET_BANK_FILTERS,
    payload: {
      bankId: bankId,
      filters: filters
    }
  };
};

exports.setBankFilters = setBankFilters;

var associateEntries = function associateEntries(bankId, bankEntryIds) {
  return {
    type: _quizCommon.ASSOCIATE_ENTRIES,
    payload: {
      bankId: bankId,
      bankEntryIds: bankEntryIds
    }
  };
};

exports.associateEntries = associateEntries;

var disassociateEntry = function disassociateEntry(bankId, bankEntryId) {
  return {
    type: _quizCommon.DISASSOCIATE_ENTRY,
    payload: {
      bankId: bankId,
      bankEntryId: bankEntryId
    }
  };
};

exports.disassociateEntry = disassociateEntry;

var removeBank = function removeBank(bankId) {
  return {
    type: _quizCommon.REMOVE_BANK,
    payload: bankId
  };
};

exports.removeBank = removeBank;

var archiveBank = function archiveBank(bankId) {
  return {
    type: _quizCommon.ARCHIVE_BANK,
    payload: bankId
  };
};

exports.archiveBank = archiveBank;