"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = Calculator;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _formatMessage = _interopRequireDefault(require("@instructure/quiz-i18n/lib/format-message"));

var _uiButtons = require("@instructure/ui-buttons");

var _uiA11y = require("@instructure/ui-a11y");

var _uiIcons = require("@instructure/ui-icons");

var _LearnosityCalculator = _interopRequireDefault(require("../../../LearnosityCalculator"));

var CalculatorButton = function CalculatorButton(_ref) {
  var toggleCalculator = _ref.toggleCalculator,
      enabled = _ref.enabled;
  return _react.default.createElement(_uiButtons.Button, {
    icon: _uiIcons.IconCalculatorLine,
    onClick: toggleCalculator,
    disabled: !enabled
  }, _react.default.createElement(_uiA11y.ScreenReaderContent, null, (0, _formatMessage.default)('Calculator')));
};

CalculatorButton.propTypes = {
  toggleCalculator: _propTypes.default.func.isRequired,
  enabled: _propTypes.default.bool.isRequired
};

function Calculator(props) {
  return _react.default.createElement(_LearnosityCalculator.default, Object.assign({}, props, {
    render: CalculatorButton
  }));
}

Calculator.propTypes = {
  activeCalculatorId: _propTypes.default.string,
  calculatorType: _propTypes.default.oneOf(['none', 'basic', 'scientific']),
  quizSessionId: _propTypes.default.string,
  setActiveCalculatorId: _propTypes.default.func.isRequired
};