"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _uiOverlays = require("@instructure/ui-overlays");

var _uiElements = require("@instructure/ui-elements");

var _uiForms = require("@instructure/ui-forms");

var _uiButtons = require("@instructure/ui-buttons");

var _quizCommon = require("@instructure/quiz-common");

var _formatMessage = _interopRequireDefault(require("@instructure/quiz-i18n/lib/format-message"));

var OutstandingQuizzesModal =
/*#__PURE__*/
function (_Component) {
  (0, _inherits2.default)(OutstandingQuizzesModal, _Component);

  function OutstandingQuizzesModal(props) {
    var _this;

    (0, _classCallCheck2.default)(this, OutstandingQuizzesModal);
    _this = (0, _possibleConstructorReturn2.default)(this, (0, _getPrototypeOf2.default)(OutstandingQuizzesModal).call(this, props));

    _this.saveAction = function () {
      var _iteratorNormalCompletion = true;
      var _didIteratorError = false;

      var _iteratorError = void 0;

      try {
        for (var _iterator = _this.state.quizzesSelectedAndReadyToSubmit[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
          var quiz = _step.value;

          _this.props.submitOutstandingQuizSession(quiz);
        }
      } catch (err) {
        _didIteratorError = true;
        _iteratorError = err;
      } finally {
        try {
          if (!_iteratorNormalCompletion && _iterator.return != null) {
            _iterator.return();
          }
        } finally {
          if (_didIteratorError) {
            throw _iteratorError;
          }
        }
      }

      _this.props.closeModal();

      _this.props.addSuccess((0, _formatMessage.default)('Manual submission was successful.'));
    };

    _this.cancelAction = function () {
      _this.props.onDismiss && _this.props.onDismiss();

      _this.props.closeModal();
    };

    _this.sortByName = function (arr) {
      return arr.sort(function (a, b) {
        return a.name.localeCompare(b.name);
      });
    };

    _this.generateCheckboxesForOutstandingQuizzes = function () {
      var checkboxes = [];
      var quizValues = [];

      var sortedQuizSessionIdsAndUsers = _this.sortByName(_this.props.quizSessionIdsAndUsers);

      if (sortedQuizSessionIdsAndUsers && _this.props.quizSessionsData) {
        sortedQuizSessionIdsAndUsers.forEach(function (sortedQuizSession) {
          return _this.props.quizSessionsData.filter(function (quizSession) {
            return quizSession.id === sortedQuizSession.id && quizSession.status === 'in_progress';
          }).forEach(function (quizSession) {
            quizValues.push(quizSession.id);
            checkboxes.push(_react.default.createElement(_uiForms.Checkbox, {
              label: sortedQuizSession.name,
              value: quizSession.id,
              key: quizSession.id
            }));
          });
        });
      }

      return {
        checkboxes: checkboxes,
        quizValues: quizValues
      };
    };

    _this.updateListOfQuizzesToSubmit = function (value) {
      _this.setState({
        quizzesSelectedAndReadyToSubmit: value
      });
    };

    _this.closeModalOnClick = function () {
      _this.props.closeModal(_quizCommon.OUTSTANDING_QUIZZES_MODAL);
    };

    _this.populateCheckboxesOnOpen = function () {
      var checkboxData = _this.generateCheckboxesForOutstandingQuizzes();

      _this.setState({
        quizzesSelectedAndReadyToSubmit: checkboxData.quizValues,
        checkboxes: checkboxData.checkboxes
      });
    };

    _this.state = {
      quizzesSelectedAndReadyToSubmit: [],
      checkboxes: []
    };
    return _this;
  }

  (0, _createClass2.default)(OutstandingQuizzesModal, [{
    key: "render",
    value: function render() {
      return _react.default.createElement(_uiOverlays.Modal, {
        open: this.props.open,
        onOpen: this.populateCheckboxesOnOpen,
        label: (0, _formatMessage.default)('Attempts in Progress'),
        mountNode: this.props.mountNode,
        size: "small"
      }, _react.default.createElement(_uiOverlays.Modal.Header, null, _react.default.createElement(_uiElements.Heading, null, (0, _formatMessage.default)('Attempts in Progress')), _react.default.createElement(_uiButtons.CloseButton, {
        onClick: this.closeModalOnClick,
        placement: "end",
        offset: "medium",
        variant: "icon"
      }, (0, _formatMessage.default)('Close'))), _react.default.createElement(_uiOverlays.Modal.Body, null, _react.default.createElement("p", null, (0, _formatMessage.default)('These assessment attempts have not been submitted. \
                  Instructors can submit attempts manually by selecting \
                  student name(s) from the list below.')), _react.default.createElement(_uiForms.CheckboxGroup, {
        name: "outstandingQuizzesSubmissionCheckboxes",
        description: (0, _formatMessage.default)('Students'),
        value: this.state.quizzesSelectedAndReadyToSubmit,
        onChange: this.updateListOfQuizzesToSubmit
      }, this.state.checkboxes)), _react.default.createElement(_uiOverlays.Modal.Footer, null, _react.default.createElement(_uiButtons.Button, {
        onClick: this.cancelAction,
        margin: "xxx-small",
        "data-automation": "sdk-outstanding-quizzes-cancel"
      }, (0, _formatMessage.default)('Cancel')), _react.default.createElement(_uiButtons.Button, {
        onClick: this.saveAction,
        margin: "xxx-small",
        variant: "primary",
        disabled: !this.state.quizzesSelectedAndReadyToSubmit.length,
        "data-automation": "sdk-outstanding-quizzes-submit"
      }, (0, _formatMessage.default)('Submit Manually'))));
    }
  }]);
  OutstandingQuizzesModal.displayName = "OutstandingQuizzesModal";
  return OutstandingQuizzesModal;
}(_react.Component);

exports.default = OutstandingQuizzesModal;
OutstandingQuizzesModal.propTypes = {
  addSuccess: _propTypes.default.func.isRequired,
  closeModal: _propTypes.default.func.isRequired,
  submitOutstandingQuizSession: _propTypes.default.func,
  open: _propTypes.default.bool,
  mountNode: _propTypes.default.string,
  onSubmit: _propTypes.default.func,
  onDismiss: _propTypes.default.func,
  quizSessionIdsAndUsers: _propTypes.default.array.isRequired,
  quizSessionsData: _propTypes.default.arrayOf(_propTypes.default.shape({
    id: _propTypes.default.string.isRequired,
    name: _propTypes.default.string.isRequired
  })).isRequired
};
OutstandingQuizzesModal.defaultProps = {
  mountNode: null,
  onSubmit: OutstandingQuizzesModal.submitOutstanding,
  onDismiss: null,
  closeModal: null
};