"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf3 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _formatMessage = _interopRequireDefault(require("@instructure/quiz-i18n/lib/format-message"));

var _uiLayout = require("@instructure/ui-layout");

var _uiOverlays = require("@instructure/ui-overlays");

var _uiButtons = require("@instructure/ui-buttons");

var _uiElements = require("@instructure/ui-elements");

var _alertHelpers = require("../../../../common/util/alertHelpers");

var _uiA11y = require("@instructure/ui-a11y");

var ModerateTray =
/*#__PURE__*/
function (_Component) {
  (0, _inherits2.default)(ModerateTray, _Component);

  function ModerateTray() {
    var _getPrototypeOf2;

    var _this;

    (0, _classCallCheck2.default)(this, ModerateTray);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = (0, _possibleConstructorReturn2.default)(this, (_getPrototypeOf2 = (0, _getPrototypeOf3.default)(ModerateTray)).call.apply(_getPrototypeOf2, [this].concat(args)));
    _this.state = {
      isTruncated: false
    };

    _this.handleUpdate = function (isTruncated) {
      if (_this.state.isTruncated !== isTruncated) {
        _this.setState({
          isTruncated: isTruncated
        });
      }
    };

    _this.onClose = function () {
      _this.props.onClose();
    };

    _this.handleTrayExited = function () {
      _this.setState({
        isTruncated: false
      });
    };

    _this.renderChildren = function () {
      return _react.default.Children.map(_this.props.children, function (child) {
        if (!child) return null;
        return _react.default.cloneElement(child, {
          trayResetFocus: function trayResetFocus() {
            return _this.closeRef.focus();
          }
        });
      });
    };

    _this.setCloseRef = function (el) {
      return _this.closeRef = el;
    };

    _this.setTrayRef = function (el) {
      return _this.trayRef = el;
    };

    _this.getTrayRef = function () {
      return _this.trayRef;
    };

    return _this;
  }

  (0, _createClass2.default)(ModerateTray, [{
    key: "renderName",
    value: function renderName(renderProps) {
      var focused = renderProps && renderProps.focused;
      return (// eslint-disable-next-line jsx-a11y/no-noninteractive-tabindex
        // When using TruncateText inside a Tooltip, a focusable wrapper element is required
        // tabIndex={0} makes the div focusable and allows KO users to access the tooltip
        _react.default.createElement(_uiLayout.View, {
          display: "inline-block",
          borderRadius: "small",
          position: "relative",
          focused: this.state.isTruncated && focused,
          as: "h2",
          tabIndex: this.state.isTruncated ? 0 : null
        }, _react.default.createElement(_uiA11y.ScreenReaderContent, null, this.labelText()), _react.default.createElement(_uiElements.TruncateText, {
          "aria-hidden": "true",
          maxLines: 2,
          truncate: "character",
          onUpdate: this.handleUpdate
        }, this.labelText()))
      );
    }
  }, {
    key: "labelText",
    value: function labelText() {
      if (this.props.participantName) {
        return this.props.participantName;
      }

      return (0, _formatMessage.default)('Moderate');
    }
  }, {
    key: "render",
    value: function render() {
      var _this2 = this;

      return _react.default.createElement(_uiOverlays.Tray, {
        label: this.labelText(),
        liveRegion: _alertHelpers.liveRegion,
        onClose: this.onClose,
        onDismiss: this.props.closeTray,
        onExited: this.handleTrayExited,
        open: this.props.isOpen,
        placement: "end",
        shouldCloseOnDocumentClick: true,
        ref: this.setTrayRef
      }, _react.default.createElement(_uiButtons.CloseButton, {
        placement: "start",
        offset: "x-small",
        variant: "icon",
        onClick: this.props.closeTray,
        buttonRef: this.setCloseRef
      }, (0, _formatMessage.default)('Close')), _react.default.createElement(_uiLayout.View, {
        as: "div",
        padding: "medium"
      }, this.state.isTruncated ? _react.default.createElement(_uiOverlays.Tooltip, {
        placement: "start",
        tip: this.labelText(),
        mountNode: this.getTrayRef || null
      }, function (_ref) {
        var focused = _ref.focused;
        return _this2.renderName({
          focused: focused
        });
      }) : this.renderName(), this.renderChildren()));
    }
  }]);
  ModerateTray.displayName = "ModerateTray";
  return ModerateTray;
}(_react.Component);

exports.default = ModerateTray;
ModerateTray.propTypes = {
  children: _propTypes.default.node.isRequired,
  closeTray: _propTypes.default.func.isRequired,
  isOpen: _propTypes.default.bool.isRequired,
  onClose: _propTypes.default.func,
  participantName: _propTypes.default.string
};
ModerateTray.defaultProps = {
  participantName: null
};